<template>
  <div>
    <b-form-textarea
      :id="id"
      v-model="content"
      :aria-describedby="ariaDescribedby"
      :state="state"
      :placeholder="placeholder"
      :maxlength="limit"
      :required="required"
      @input="handleInput"
    />
    <span id="characterCounter">{{
      (this.content != null ? this.content.toString().length : 0) +
      "/" +
      this.limit +
      " " +
      this.character
    }}</span>
  </div>
</template>

<script lang="ts">
import { BFormTextarea } from "bootstrap-vue";
import Vue from "vue";
Vue.component("b-form-textarea", BFormTextarea);

export default Vue.extend({
  data() {
    return {
      content: this.value,
    };
  },
  watch: {
    value(newVal) {
      this.content = newVal;
    },
  },
  props: {
    character: {
      default: null,
      type: String,
    },
    limit: {
      default: 5000,
      type: Number,
    },
    id: {
      default: null,
      type: String,
    },
    value: {
      default: null,
      type: String,
    },
    ariaDescribedby: {
      default: null,
      type: String,
    },
    placeholder: {
      default: null,
      type: String,
    },
    required: {
      default: null,
      type: Boolean,
    },
    state: {},
  },
  methods: {
    handleInput() {
      this.$emit("input", this.content);
    },
  },
});
</script>
<style scoped>
#characterCounter {
  position: absolute;
  bottom: 0px;
  right: 15px;
}
</style>
